//ICC-AVR application builder : 2010-5-9 14:14:31
// Target : M16
// Crystal: 8.000Mhz

#include <iom16v.h>
#include <macros.h>
#define BTL_9600 103         //岨Ϊ9600 8MHZ
#define uchar unsigned char  
#define uint unsigned int
#include "TC35ָ.h"
/*--------------------------/
        Ĵ
---------------------------*/
uchar i_TC35_RECE;

uchar i_receive,
      TC35_RE[100],
	 
	  TC35_MAX,
	  i_TC35;
/*--------------------------/	  
     Ƭ˿ڶ	                 
/--------------------------*/  
void port_init(void)
{
 PORTA = 0xff;
 DDRA  = 0xff;
 PORTB = 0xff;
 DDRB  = 0xff;
 PORTC = 0xff; //m103 output only
 DDRC  = 0xff;
 PORTD = 0xff;
 DDRD  = 0x00;
}

/*--------------------------/	  
     ʱ
	 10msģʽ	                 
/--------------------------*/  
void timer1_init(void)
{
 TCCR1B = 0x00; //stop
 TCNT1H = 0xFB; //setup
 TCNT1L = 0x1E;
 TCCR1A = 0x00;
 TCCR1B = 0x03; //start Timer
}
/*--------------------------/	  
     ʱж
	 10msģʽ	                 
/--------------------------*/  
#pragma interrupt_handler timer1_ovf_isr:iv_TIM1_OVF
void timer1_ovf_isr(void)
{
 //TIMER1 has overflowed
 TCNT1H = 0xFB; //reload counter high value
 TCNT1L = 0x1E; //reload counter low value
}
/*--------------------------/	  
    ڳʼ
	Ϊ9600	                 
/--------------------------*/ 
void uart0_init(void)
{//Ϊ9600Ϊ8MHz
 UCSRB = 0x00; //disable while setting baud rate
 UCSRA = 0x02;
 UCSRC = BIT(URSEL) | 0x06;
 UBRR = BTL_9600; //set baud rate lo
 UCSRB = 0xD8;
}
/*--------------------------/	  
    ڽж϶              
/--------------------------*/ 
#pragma interrupt_handler uart0_rx_isr:iv_USART0_RXC
void uart0_rx_isr(void)
{//ڽжϳ
 //while(!(UCSRA&(1<<RXC)));
 i_receive=UDR;
 TC35_RE[i_TC35_RECE]=i_receive;
 i_TC35_RECE=i_TC35_RECE+1;
 if(i_TC35_RECE>TC35_MAX){TC35_MAX=i_TC35_RECE;}
}
/*--------------------------/	  
    ڷж϶              
/--------------------------*/ 
#pragma interrupt_handler uart0_tx_isr:iv_USART0_TXC
void uart0_tx_isr(void)
{/*ڷжϳ*/}
/*--------------------------/	  
    ڵֽڷͶ              
/--------------------------*/ 
void send_uart(unsigned char i_tremit)
{ 
  while(!(UCSRA&0x20));
  UDR=i_tremit;
}
/*--------------------------/	  
    ʼ            
/--------------------------*/ 
void init_devices(void)
{
 CLI();           /*ж*/
 port_init();     /*˿ڶģʽ*/
 timer1_init();   /*ʱģʽ*/
 uart0_init();    /*ڶģʽ*/
 MCUCR = 0x00;    /*ָʾ*/
 GICR  = 0x00;    /*ģʽ*/
 TIMSK = 0x04;    /*ʱжʹܷ*/
 SEI();           /*ʹж*/
}
/*--------------------------/	  
    ʱ        
/--------------------------*/ 
void delay(uint i)
{unsigned int i_delay,j_delay;
for(i_delay=0;i_delay<i;i_delay++)
{for(j_delay=0;j_delay<1000;j_delay++)
{;}}
}
void main(void)
{
 init_devices();
 delay(1000);
 TC35_MAX=0;
 AT_RST();
while(1)
{delay(1000);

if(TC35_MAX>0)
{
//----------------
//λ
if(TC35_CON==RST){
if((TC35_RE[7]=='O')&&(TC35_RE[8]=='K'))
{PORTA=(0XFF-0X01);TC35_CON=TC35RET;
AT_CMGF();}
else{PORTB=(0XFF-0X02);}

}
//TEXTģʽ
else if(TC35_CON==CMGF){
if((TC35_RE[12]=='O')&&(TC35_RE[13]=='K'))
{PORTA=(0XFF-0X02);TC35_CON=TC35RET;
AT_CREG();}
else{PORTB=(0XFF-0X02);}
}

//ѯ״̬
else if(TC35_CON==CREG){
if(((TC35_RE[18]=='0')&&(TC35_RE[20]=='1'))||((TC35_RE[18]=='0')&&(TC35_RE[20]=='5')))
{PORTA=(0XFF-0X04);PORTB=0XFF;TC35_CON=TC35RET;AT_CMGR();}
else{PORTB=(0XFF-0X02);AT_CREG();}
}
//ִж
else if(TC35_CON==CMGR){
if(TC35_MAX==30){AT_CMGR();}
else //if((TC35_MAX==77)||(TC35_MAX==79))
{delay(1000);
PORTA=(0XFF-0X08);PORTB=0XFF;
if(TC35_RE[69]=='0')
{PORTC=(0XFF-0X01);PORTB=0XFF;TC35_CON=TC35RET;delay(1000);AT_CMGD();}
else if(TC35_RE[69]=='1')
{PORTC=(0XFF-0X02);PORTB=0XFF;TC35_CON=TC35RET;delay(1000);AT_CMGD();}
else if(TC35_RE[69]=='2')
{PORTC=(0XFF-0X04);PORTB=0XFF;TC35_CON=TC35RET;delay(1000);AT_CMGD();}
else if(TC35_RE[69]=='3')
{PORTC=(0XFF-0X08);PORTB=0XFF;TC35_CON=TC35RET;delay(1000);AT_CMGD();}
else if(TC35_RE[69]=='4')
{PORTC=(0XFF-0X10);PORTB=0XFF;TC35_CON=TC35RET;delay(1000);AT_CMGD();}
else if(TC35_RE[69]=='5')
{PORTC=(0XFF-0X20);PORTB=0XFF;TC35_CON=TC35RET;delay(1000);AT_CMGD();}
else if(TC35_RE[69]=='6')
{PORTC=(0XFF-0X40);PORTB=0XFF;TC35_CON=TC35RET;delay(1000);AT_CMGD();}
else if(TC35_RE[69]=='7')
{PORTC=(0XFF-0X80);PORTB=0XFF;TC35_CON=TC35RET;delay(1000);AT_CMGD();}
else{TC35_CON=TC35RET;AT_CMGR();}
}
}
//ɾ
else if(TC35_CON==CMGD){delay(1000);
if((TC35_RE[12]=='O')&&(TC35_RE[13]=='K'))
{PORTA=(0XFF-0X10);PORTB=0XFF;delay(1000);AT_CSCA();}
else{PORTB=(0XFF-0X02);}
}
//дϢĺ
else if(TC35_CON==CSCA){delay(1000);
if((TC35_RE[25]=='O')&&(TC35_RE[26]=='K'))
{PORTA=(0XFF-0X20);PORTB=0XFF;delay(1000);AT_CMGS();}
else{PORTB=(0XFF-0X02);}
}
//д
else if(TC35_CON==CMGS){delay(1000);
if((TC35_RE[22]==0X3E)&&(TC35_RE[23]==0X20))
{PORTA=(0XFF-0X40);PORTB=0XFF;delay(1000);ATNAME();}
else{PORTB=(0XFF-0X02);}
}
//Ϸؼɨ
else if(TC35_CON==ATDAT){delay(1000);
if((TC35_RE[0]=='+')||(TC35_RE[0]==0x1A))
{PORTA=(0XFF-0X80);PORTB=0XFF;delay(1000);AT_CMGR();}
else{PORTB=(0XFF-0X02);}
}



//send_uart(TC35_MAX);
//λ
for(i_TC35=0;i_TC35<=TC35_MAX;i_TC35++)
{TC35_RE[i_TC35]=0;}
i_TC35_RECE=0;
TC35_MAX=0;
}

}
}

